# Git 常用命令

## GIt初始化配置

``` shell
git config --global user.name "用户名"
git config --global user.email "电子与邮箱地址"
git config --global core.editor vim	# 配置文本编辑器
git config --list	# 配置检查
```

## GIt仓库创建

​		在本地创建Git仓库：

``` shell
git init
```

​		克隆网络仓库：

``` shell
git clone "仓库链接"
```

> 在本地创建仓库时要先创建文件夹，进入文件夹后在执行`git init`来初始化仓库。
>
> 网络克隆的仓库会自己创建文件，不用自己创建。

## Git文件操作

### 检查当前文件状态
可以使用`git status`命令查看那些文件处于什么状态。

### 跟踪新文件

可以使用`git add`开始跟踪一个文件。

### 暂存已修改的文件

可以使用`git add`把已跟踪的文件添加到暂存区。

> `git add`是个多功能命令：可以用它开始跟踪新文件，或者把已跟踪的文件放到暂存区，还能用于合并时把有冲突的文件标记为已解决状态等。

> 当你对暂存区的文件再次进行编辑时，Git默认提交的时`git add`时的版本，你需要再次使用`git add`将其添加到暂存区。

### 查看文件修改

可以使用`git diff`命令查看暂存的文件修改内容

### 提交更新

在文件修改完毕后可以通过`git commit`命令来提交更新。

### 移除文件

`git rm`命令从Git仓库中删除文件的跟踪

### 移动文件

`git mv file_from file_to`

## 查看历史

`git log`
