# Linux Java Web环境 部署

## 前言

本文档根据华为云官方ECS官方文档练习编写。

[手工部署Java Web环境](https://support.huaweicloud.com/bestpractice-ecs/zh-cn_topic_0114925482.html)

### 实验环境

CentOS 7.6

## 准备

### 云环境准备

根据实验需求配置和购买云服务。

* VPC&安全组
* ECS
* EIP

### 系统环境准备

``` shell
# 创建安装目录
mkdir /home/webDemo
mkdir /home/webDemo/{jdk,tomcat}
# 下载软件包
wget https://download.oracle.com/java/17/latest/jdk-17_linux-x64_bin.tar.gz
wget https://mirrors.tuna.tsinghua.edu.cn/apache/tomcat/tomcat-8/v8.5.76/bin/apache-tomcat-8.5.76.tar.gz
```

## 开始部署

### 安装JDK

```shell
# 解压JDK包到jdk目录下
tar -xvf jdk-17_linux-x64_bin.tar.gz -C /home/webDemo/jdk/
# 配置环境变量
vim /etc/profile
	#set java environment
    export JAVA_HOME=/home/webDemo/jdk/jdk-17
    export CLASSPATH=.:$JAVA_HOME/lib/dt.jar:$JAVA_HOME/lib/tools.jar
    export PATH=$JAVA_HOME/bin:$PATH

# 刷新环境变量
source /etc/profile
# 验证安装
java --version

```

### 安装Tomcat

```shell
# 解压Tomcat的Tomcat目录下
tar -zxvf apache-tomcat-8.5.76.tar.gz -C /home/webDemo/tomcat
# 启动tomcat
bash /home/webDemo/tomcat/apache-tomcat-8.5.76/bin/startup.sh
```



