## LAMP环境安装

### 环境介绍

​		LAMP是Linux+Apahce+MySQL+PHP组成的动态网站应用环境，可以在该环境中部署PHP开发的站点。

### 部署环境

平台：华为云

云主机：2c4g

系统：centos 7.6

软件版本：

​		Apache：Apache/2.4.6 (CentOS)
​		MySQL：Ver 15.1 Distrib 5.5.68-MariaDB, for Linux (x86_64) using readline 5.1
​		PHP：PHP 7.2.34 (cli)

### 配置过程

#### 安装Apache

```shell
yum install httpd
systemctl enable --now httpd	# 开启apache服务
```

​		安装完毕后在浏览器访问服务器的IP地址，如果出现以下页面，就证明可以成功访问了。

<img src="images/image-20211016154345570.png" alt="成功访问到Apache的欢迎页面" style="zoom: 50%;" />

#### 安装MySQL

​		因为MySQL已经被Oracle收购，CentOS已经使用Mariadb来代替MySQL数据库。

```shell
yum install mariadb-server
systemctl enable --now mariadb
mysql_secure_installction	# 初始化mariadb数据库
Enter current password for root (enter for none):  # 输入root密码
Change the root password? [Y/n] n	# 是否更改root密码
Remove anonymous users? [Y/n] y	# 是否删除匿名用户
Disallow root login remotely? [Y/n] y	# 是否允许root远程登陆
Remove test database and access to it? [Y/n] y	# 是否删除测试数据库和数据
Reload privilege tables now? [Y/n] y	# 是否刷新授权表
```

#### 安装PHP

```shell
rpm -Uvh https://mirror.webtatic.com/yum/el7/epel-release.rpm
rpm -Uvh https://mirror.webtatic.com/yum/el7/webtatic-release.rpm
yum install -y php72w php72w-fpm php72w-mysql php72w-devel
systemctl enable --now php-fpm
```

### Apache虚拟主机配置文档

Apache虚拟主机配置文件放在"/etc/httpd/conf.d/"

```shell
<VirtualHost *:80>
        DocumentRoot "/var/www/wordpress"

        <Directory "/var/www/wordpress">
                AllowOverride None
                Require all granted
        </Directory>
</VirtualHost>
```

## 进行环境测试

### 准备PHP测试文件

```php
<?php
    phpinfo();
?>
```

将测试文件放到Apache的默认测试目录"/var/www/html"，重启Apache服务，接着在浏览器访问”IP/测试文件名“，得到如下结果就说明可以安装成功。

<img src="images/image-20211016172539526.png" alt="环境安装成功" style="zoom: 50%;" />

