# 关于在使用markdown语法写文档时是否顶格的想法

最近使用markdown写的文档比较多，按照传统中文写作写作习惯，每段开头都会打上空格来区分，但是再参考其他文档档，尤其是英文文档的时候发现很少有使用空格来区分段落的，每一段都是顶格书写。

仔细看了下在typora中换行是，语法在源码层面表现是以段落来区分的，在HTML中，段落与段落之间默认是有空行的，也就是直接空一行就代表一个段落。

找找资料，发现英文写作中有两大类，齐头式和缩进式。缩进式和我们中文写作时一样，开头没有缩进，这样的话短语段之间不用做太多要求。齐头式就是不进行缩进，一般用在商贸、官方、正式的信件和学术论文中，显得更加严肃、真实和可靠。但是一篇文章只能够采用一种方式进行缩进。

放到中文文档中来看，缩进与否其实不是重点了，因为段落与段落之间都是有标记的，但是在文档中还是用齐头式来写的更加好一些。

再仔细体验了下typora的操作，很多标记语法都是顶格使用的。

## 2022年3月7日 结论 

**Markdown在技术文档编辑中不需要空格，直接顶格书写即可。**

仔细观察就会发现在一些混合排版中，都是顶格写入的，可以看下下面的格式类型：

* 无序列表是顶格使用的，如果配上空格内容的话就会变得难看。

​		空两格

* 启用无序列表，现在观察就能够发现无法对其。

